diff --git a/criu/cr-dump.c b/criu/cr-dump.c
index e209aab8a9..a1b5c398b0 100644
--- a/criu/cr-dump.c
+++ b/criu/cr-dump.c
@@ -1179,10 +1179,6 @@ static int pre_dump_one_task(struct pstree_item *item)
 	if (ret)
 		goto err_cure;
 
-	ret = task_reset_dirty_track(pid);
-	if (ret)
-		goto err_cure;
-
 	if (parasite_cure_remote(parasite_ctl))
 		pr_err("Can't cure (pid: %d) from parasite\n", pid);
 err_free:
@@ -1397,10 +1393,6 @@ static int dump_one_task(struct pstree_item *item)
 		goto err;
 	}
 
-	ret = task_reset_dirty_track(pid);
-	if (ret)
-		goto err;
-
 	close_cr_imgset(&cr_imgset);
 	exit_code = 0;
 err:
diff --git a/criu/include/mem.h b/criu/include/mem.h
index 1acc9792a3..1461d2a515 100644
--- a/criu/include/mem.h
+++ b/criu/include/mem.h
@@ -10,7 +10,6 @@ struct vm_area_list;
 struct page_pipe;
 struct pstree_item;
 
-extern int task_reset_dirty_track(int pid);
 extern bool page_is_zero(u64 pme);
 extern bool page_in_parent(bool dirty);
 extern int prepare_mm_pid(struct pstree_item *i);
diff --git a/criu/mem.c b/criu/mem.c
index 3e859105bb..a94a378cdd 100644
--- a/criu/mem.c
+++ b/criu/mem.c
@@ -30,7 +30,7 @@
 #include "protobuf.h"
 #include "images/pagemap.pb-c.h"
 
-int task_reset_dirty_track(int pid)
+static int task_reset_dirty_track(int pid)
 {
 	int ret;
 
@@ -387,7 +387,7 @@ static int __parasite_dump_pages_seized(struct parasite_ctl *ctl,
 	/*
 	 * Step 4 -- clean up
 	 */
-
+	ret = task_reset_dirty_track(ctl->pid.real);
 out_xfer:
 	if (should_xfer)
 		xfer.close(&xfer);
